﻿using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Input;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.textBox.PreviewTextInput += textBox_PreviewTextInput;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 텍스트 박스 텍스트 입력 프리뷰 처리하기 - textBox_PreviewTextInput(sender, e)

        /// <summary>
        /// 텍스트 박스 텍스트 입력 프리뷰 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void textBox_PreviewTextInput(object sender, TextCompositionEventArgs e)
        {
            e.Handled = !IsNumeric(e.Text);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 숫자 여부 구하기 - IsNumeric(source)

        /// <summary>
        /// 숫자 여부 구하기
        /// </summary>
        /// <param name="source">소스 문자열</param>
        /// <returns>숫자 여부</returns>
        private bool IsNumeric(string source)
        {
            Regex regex = new Regex("[^0-9.-]+");

            return !regex.IsMatch(source);
        }

        #endregion
    }
}